package fixtures.slim;

import com.samscdrental.dataaccess.CategoryValuesAccess;
import com.samscdrental.model.CDCategory;
import com.samscdrental.model.CDCategoryValue;
import com.samscdrental.model.adt.Count;
import com.samscdrental.model.adt.Dollar;

public class CDCategoryValues {

  private CDCategory category;
  private int rentalDays;
  private double baseRentalFee;
  private double extraDayRentalFee;

  public boolean execute() throws Exception {
    Count CountRentalDays = new Count(rentalDays);
    Dollar DollarBaseRentalFee = new Dollar(baseRentalFee);
    Dollar DollarExtraDayRentalFee = new Dollar(extraDayRentalFee);

    CDCategoryValue aCategoryValue = new CDCategoryValue
    (category, CountRentalDays,
        DollarBaseRentalFee,DollarExtraDayRentalFee);

    CategoryValuesAccess.addCategoryValue(aCategoryValue);
      return true;
  }

  public void setCategory(String category) throws Exception {
    this.category = CDCategory.parseString(category);
  }

  public void setRentalDays(int rentalDays) {
    this.rentalDays = rentalDays;
  }

  public void setBaseRentalFee(double baseRentalFee) {
    this.baseRentalFee = baseRentalFee;
  }

  public void setExtraDayRentalFee(double extraDayRentalFee) {
    this.extraDayRentalFee = extraDayRentalFee;
  }


}
